//-------------------------------------------------------------------------
//                  Sampling methods for SO(3)
//-------------------------------------------------------------------------
//
// Copyright (c) 2003 University of Illinois and Steven M. LaValle
// All rights reserved.
//
// Developed by:                Motion Strategy Laboratory
//                              University of Illinois
//                              http://msl.cs.uiuc.edu/msl/
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal with the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
//     * Redistributions of source code must retain the above copyright 
//       notice, this list of conditions and the following disclaimers.
//     * Redistributions in binary form must reproduce the above copyright 
//       notice, this list of conditions and the following disclaimers in 
//       the documentation and/or other materials provided with the 
//       distribution.
//     * Neither the names of the Motion Strategy Laboratory, University
//       of Illinois, nor the names of its contributors may be used to 
//       endorse or promote products derived from this Software without 
//       specific prior written permission.
//
// The software is provided "as is", without warranty of any kind,
// express or implied, including but not limited to the warranties of
// merchantability, fitness for a particular purpose and
// noninfringement.  In no event shall the contributors or copyright
// holders be liable for any claim, damages or other liability, whether
// in an action of contract, tort or otherwise, arising from, out of or
// in connection with the software or the use of other dealings with the
// software.
//
//-------------------------------------------------------------------------
#include <math.h>
#include <cstdlib>
#include <string>
using namespace std;

#include "sample.h"

int main(int argc, char *argv[])
{

  if (argc < 3) {
    cout << "Try this:    sample \"sampling method\" \"number of points\" \n";
    cout << "Example:    sample 3 10 \n";
    cout << "Sampling methods: \n";
    cout << "\t random quaternions = 1 \n";
    cout << "\t Sukharev grid sequence = 2 \n";
    cout << "\t layered Sukharev grid sequence = 3 \n";
    exit(-1);
  }

  int SampleMethod = atoi(argv[1]);
  int index = atoi(argv[2]);

  Sample *S = new Sample(SampleMethod);
  
  for (int i = 0; i < index; i++) {
    cout << S->ChooseState(i) << endl;
  }

  return 0;
}

